# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['DrainArgs', 'Drain']

@pulumi.input_type
class DrainArgs:
    def __init__(__self__, *,
                 app_id: pulumi.Input[str],
                 sensitive_url: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Drain resource.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[str] url: The URL for Heroku to drain your logs to. Either `url` or `sensitive_url` must be defined.
        """
        pulumi.set(__self__, "app_id", app_id)
        if sensitive_url is not None:
            pulumi.set(__self__, "sensitive_url", sensitive_url)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="appId")
    def app_id(self) -> pulumi.Input[str]:
        """
        Heroku app ID (do not use app name)
        """
        return pulumi.get(self, "app_id")

    @app_id.setter
    def app_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "app_id", value)

    @property
    @pulumi.getter(name="sensitiveUrl")
    def sensitive_url(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "sensitive_url")

    @sensitive_url.setter
    def sensitive_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sensitive_url", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The URL for Heroku to drain your logs to. Either `url` or `sensitive_url` must be defined.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)


@pulumi.input_type
class _DrainState:
    def __init__(__self__, *,
                 app_id: Optional[pulumi.Input[str]] = None,
                 sensitive_url: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Drain resources.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[str] token: The unique token for your created drain.
        :param pulumi.Input[str] url: The URL for Heroku to drain your logs to. Either `url` or `sensitive_url` must be defined.
        """
        if app_id is not None:
            pulumi.set(__self__, "app_id", app_id)
        if sensitive_url is not None:
            pulumi.set(__self__, "sensitive_url", sensitive_url)
        if token is not None:
            pulumi.set(__self__, "token", token)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="appId")
    def app_id(self) -> Optional[pulumi.Input[str]]:
        """
        Heroku app ID (do not use app name)
        """
        return pulumi.get(self, "app_id")

    @app_id.setter
    def app_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "app_id", value)

    @property
    @pulumi.getter(name="sensitiveUrl")
    def sensitive_url(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "sensitive_url")

    @sensitive_url.setter
    def sensitive_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sensitive_url", value)

    @property
    @pulumi.getter
    def token(self) -> Optional[pulumi.Input[str]]:
        """
        The unique token for your created drain.
        """
        return pulumi.get(self, "token")

    @token.setter
    def token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "token", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The URL for Heroku to drain your logs to. Either `url` or `sensitive_url` must be defined.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)


class Drain(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_id: Optional[pulumi.Input[str]] = None,
                 sensitive_url: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a Heroku Drain resource. This can be used to
        create and manage Log Drains on Heroku.

        ## Example Usage

        ## Importing

        When importing a Heroku drain resource, the ID must be built using the app name colon the unique ID from the Heroku API.
        For an app named `production-api` with a drain ID of `b85d9224-310b-409b-891e-c903f5a40568` and the `url` attribute value
        defined for the resource, you would import it as:

        When importing a Heroku drain resource, the ID must be built using the app name colon the unique ID from the Heroku API.
        For an app named `production-api` with a drain ID of `b85d9224-310b-409b-891e-c903f5a40568` and the `sensitive_url` attribute value
        defined for the resource, you would import it as:

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[str] url: The URL for Heroku to drain your logs to. Either `url` or `sensitive_url` must be defined.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DrainArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Heroku Drain resource. This can be used to
        create and manage Log Drains on Heroku.

        ## Example Usage

        ## Importing

        When importing a Heroku drain resource, the ID must be built using the app name colon the unique ID from the Heroku API.
        For an app named `production-api` with a drain ID of `b85d9224-310b-409b-891e-c903f5a40568` and the `url` attribute value
        defined for the resource, you would import it as:

        When importing a Heroku drain resource, the ID must be built using the app name colon the unique ID from the Heroku API.
        For an app named `production-api` with a drain ID of `b85d9224-310b-409b-891e-c903f5a40568` and the `sensitive_url` attribute value
        defined for the resource, you would import it as:

        :param str resource_name: The name of the resource.
        :param DrainArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DrainArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_id: Optional[pulumi.Input[str]] = None,
                 sensitive_url: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DrainArgs.__new__(DrainArgs)

            if app_id is None and not opts.urn:
                raise TypeError("Missing required property 'app_id'")
            __props__.__dict__["app_id"] = app_id
            __props__.__dict__["sensitive_url"] = None if sensitive_url is None else pulumi.Output.secret(sensitive_url)
            __props__.__dict__["url"] = url
            __props__.__dict__["token"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["sensitiveUrl"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Drain, __self__).__init__(
            'heroku:drain/drain:Drain',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            app_id: Optional[pulumi.Input[str]] = None,
            sensitive_url: Optional[pulumi.Input[str]] = None,
            token: Optional[pulumi.Input[str]] = None,
            url: Optional[pulumi.Input[str]] = None) -> 'Drain':
        """
        Get an existing Drain resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[str] token: The unique token for your created drain.
        :param pulumi.Input[str] url: The URL for Heroku to drain your logs to. Either `url` or `sensitive_url` must be defined.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DrainState.__new__(_DrainState)

        __props__.__dict__["app_id"] = app_id
        __props__.__dict__["sensitive_url"] = sensitive_url
        __props__.__dict__["token"] = token
        __props__.__dict__["url"] = url
        return Drain(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="appId")
    def app_id(self) -> pulumi.Output[str]:
        """
        Heroku app ID (do not use app name)
        """
        return pulumi.get(self, "app_id")

    @property
    @pulumi.getter(name="sensitiveUrl")
    def sensitive_url(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "sensitive_url")

    @property
    @pulumi.getter
    def token(self) -> pulumi.Output[str]:
        """
        The unique token for your created drain.
        """
        return pulumi.get(self, "token")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[Optional[str]]:
        """
        The URL for Heroku to drain your logs to. Either `url` or `sensitive_url` must be defined.
        """
        return pulumi.get(self, "url")

