# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SlugArgs', 'Slug']

@pulumi.input_type
class SlugArgs:
    def __init__(__self__, *,
                 app_id: pulumi.Input[str],
                 process_types: pulumi.Input[Mapping[str, pulumi.Input[str]]],
                 buildpack_provided_description: Optional[pulumi.Input[str]] = None,
                 checksum: Optional[pulumi.Input[str]] = None,
                 commit: Optional[pulumi.Input[str]] = None,
                 commit_description: Optional[pulumi.Input[str]] = None,
                 file_path: Optional[pulumi.Input[str]] = None,
                 file_url: Optional[pulumi.Input[str]] = None,
                 stack: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Slug resource.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] process_types: Map of [processes to launch on Heroku Dynos](https://devcenter.heroku.com/articles/process-model)
        :param pulumi.Input[str] buildpack_provided_description: Description of language or app framework, `"Ruby/Rack"`;
               displayed as the app's language in the Heroku Dashboard
        :param pulumi.Input[str] checksum: Hash of the slug for verifying its integrity, auto-generated from contents of `file_path` or `file_url`,
               `SHA256:e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855`
        :param pulumi.Input[str] commit: Identification of the code with your version control system (eg: SHA of the git HEAD), `"60883d9e8947a57e04dc9124f25df004866a2051"`
        :param pulumi.Input[str] commit_description: Description of the provided commit
        :param pulumi.Input[str] file_path: Local path to a slug archive, `"slugs/current.tgz"`
        :param pulumi.Input[str] file_url: **https** URL to a slug archive, `"https://example.com/slugs/app-v1.tgz"`
        :param pulumi.Input[str] stack: Name or ID of the [Heroku stack](https://devcenter.heroku.com/articles/stack)
        """
        pulumi.set(__self__, "app_id", app_id)
        pulumi.set(__self__, "process_types", process_types)
        if buildpack_provided_description is not None:
            pulumi.set(__self__, "buildpack_provided_description", buildpack_provided_description)
        if checksum is not None:
            pulumi.set(__self__, "checksum", checksum)
        if commit is not None:
            pulumi.set(__self__, "commit", commit)
        if commit_description is not None:
            pulumi.set(__self__, "commit_description", commit_description)
        if file_path is not None:
            pulumi.set(__self__, "file_path", file_path)
        if file_url is not None:
            pulumi.set(__self__, "file_url", file_url)
        if stack is not None:
            pulumi.set(__self__, "stack", stack)

    @property
    @pulumi.getter(name="appId")
    def app_id(self) -> pulumi.Input[str]:
        """
        Heroku app ID (do not use app name)
        """
        return pulumi.get(self, "app_id")

    @app_id.setter
    def app_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "app_id", value)

    @property
    @pulumi.getter(name="processTypes")
    def process_types(self) -> pulumi.Input[Mapping[str, pulumi.Input[str]]]:
        """
        Map of [processes to launch on Heroku Dynos](https://devcenter.heroku.com/articles/process-model)
        """
        return pulumi.get(self, "process_types")

    @process_types.setter
    def process_types(self, value: pulumi.Input[Mapping[str, pulumi.Input[str]]]):
        pulumi.set(self, "process_types", value)

    @property
    @pulumi.getter(name="buildpackProvidedDescription")
    def buildpack_provided_description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of language or app framework, `"Ruby/Rack"`;
        displayed as the app's language in the Heroku Dashboard
        """
        return pulumi.get(self, "buildpack_provided_description")

    @buildpack_provided_description.setter
    def buildpack_provided_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "buildpack_provided_description", value)

    @property
    @pulumi.getter
    def checksum(self) -> Optional[pulumi.Input[str]]:
        """
        Hash of the slug for verifying its integrity, auto-generated from contents of `file_path` or `file_url`,
        `SHA256:e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855`
        """
        return pulumi.get(self, "checksum")

    @checksum.setter
    def checksum(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "checksum", value)

    @property
    @pulumi.getter
    def commit(self) -> Optional[pulumi.Input[str]]:
        """
        Identification of the code with your version control system (eg: SHA of the git HEAD), `"60883d9e8947a57e04dc9124f25df004866a2051"`
        """
        return pulumi.get(self, "commit")

    @commit.setter
    def commit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "commit", value)

    @property
    @pulumi.getter(name="commitDescription")
    def commit_description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the provided commit
        """
        return pulumi.get(self, "commit_description")

    @commit_description.setter
    def commit_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "commit_description", value)

    @property
    @pulumi.getter(name="filePath")
    def file_path(self) -> Optional[pulumi.Input[str]]:
        """
        Local path to a slug archive, `"slugs/current.tgz"`
        """
        return pulumi.get(self, "file_path")

    @file_path.setter
    def file_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_path", value)

    @property
    @pulumi.getter(name="fileUrl")
    def file_url(self) -> Optional[pulumi.Input[str]]:
        """
        **https** URL to a slug archive, `"https://example.com/slugs/app-v1.tgz"`
        """
        return pulumi.get(self, "file_url")

    @file_url.setter
    def file_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_url", value)

    @property
    @pulumi.getter
    def stack(self) -> Optional[pulumi.Input[str]]:
        """
        Name or ID of the [Heroku stack](https://devcenter.heroku.com/articles/stack)
        """
        return pulumi.get(self, "stack")

    @stack.setter
    def stack(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stack", value)


@pulumi.input_type
class _SlugState:
    def __init__(__self__, *,
                 app_id: Optional[pulumi.Input[str]] = None,
                 blobs: Optional[pulumi.Input[Sequence[pulumi.Input['SlugBlobArgs']]]] = None,
                 buildpack_provided_description: Optional[pulumi.Input[str]] = None,
                 checksum: Optional[pulumi.Input[str]] = None,
                 commit: Optional[pulumi.Input[str]] = None,
                 commit_description: Optional[pulumi.Input[str]] = None,
                 file_path: Optional[pulumi.Input[str]] = None,
                 file_url: Optional[pulumi.Input[str]] = None,
                 process_types: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 size: Optional[pulumi.Input[int]] = None,
                 stack: Optional[pulumi.Input[str]] = None,
                 stack_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Slug resources.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[Sequence[pulumi.Input['SlugBlobArgs']]] blobs: Slug archive (compressed tar of executable code)
        :param pulumi.Input[str] buildpack_provided_description: Description of language or app framework, `"Ruby/Rack"`;
               displayed as the app's language in the Heroku Dashboard
        :param pulumi.Input[str] checksum: Hash of the slug for verifying its integrity, auto-generated from contents of `file_path` or `file_url`,
               `SHA256:e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855`
        :param pulumi.Input[str] commit: Identification of the code with your version control system (eg: SHA of the git HEAD), `"60883d9e8947a57e04dc9124f25df004866a2051"`
        :param pulumi.Input[str] commit_description: Description of the provided commit
        :param pulumi.Input[str] file_path: Local path to a slug archive, `"slugs/current.tgz"`
        :param pulumi.Input[str] file_url: **https** URL to a slug archive, `"https://example.com/slugs/app-v1.tgz"`
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] process_types: Map of [processes to launch on Heroku Dynos](https://devcenter.heroku.com/articles/process-model)
        :param pulumi.Input[int] size: Slug archive filesize in bytes
        :param pulumi.Input[str] stack: Name or ID of the [Heroku stack](https://devcenter.heroku.com/articles/stack)
        :param pulumi.Input[str] stack_id: [Heroku stack](https://devcenter.heroku.com/articles/stack) ID
        """
        if app_id is not None:
            pulumi.set(__self__, "app_id", app_id)
        if blobs is not None:
            pulumi.set(__self__, "blobs", blobs)
        if buildpack_provided_description is not None:
            pulumi.set(__self__, "buildpack_provided_description", buildpack_provided_description)
        if checksum is not None:
            pulumi.set(__self__, "checksum", checksum)
        if commit is not None:
            pulumi.set(__self__, "commit", commit)
        if commit_description is not None:
            pulumi.set(__self__, "commit_description", commit_description)
        if file_path is not None:
            pulumi.set(__self__, "file_path", file_path)
        if file_url is not None:
            pulumi.set(__self__, "file_url", file_url)
        if process_types is not None:
            pulumi.set(__self__, "process_types", process_types)
        if size is not None:
            pulumi.set(__self__, "size", size)
        if stack is not None:
            pulumi.set(__self__, "stack", stack)
        if stack_id is not None:
            pulumi.set(__self__, "stack_id", stack_id)

    @property
    @pulumi.getter(name="appId")
    def app_id(self) -> Optional[pulumi.Input[str]]:
        """
        Heroku app ID (do not use app name)
        """
        return pulumi.get(self, "app_id")

    @app_id.setter
    def app_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "app_id", value)

    @property
    @pulumi.getter
    def blobs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SlugBlobArgs']]]]:
        """
        Slug archive (compressed tar of executable code)
        """
        return pulumi.get(self, "blobs")

    @blobs.setter
    def blobs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SlugBlobArgs']]]]):
        pulumi.set(self, "blobs", value)

    @property
    @pulumi.getter(name="buildpackProvidedDescription")
    def buildpack_provided_description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of language or app framework, `"Ruby/Rack"`;
        displayed as the app's language in the Heroku Dashboard
        """
        return pulumi.get(self, "buildpack_provided_description")

    @buildpack_provided_description.setter
    def buildpack_provided_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "buildpack_provided_description", value)

    @property
    @pulumi.getter
    def checksum(self) -> Optional[pulumi.Input[str]]:
        """
        Hash of the slug for verifying its integrity, auto-generated from contents of `file_path` or `file_url`,
        `SHA256:e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855`
        """
        return pulumi.get(self, "checksum")

    @checksum.setter
    def checksum(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "checksum", value)

    @property
    @pulumi.getter
    def commit(self) -> Optional[pulumi.Input[str]]:
        """
        Identification of the code with your version control system (eg: SHA of the git HEAD), `"60883d9e8947a57e04dc9124f25df004866a2051"`
        """
        return pulumi.get(self, "commit")

    @commit.setter
    def commit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "commit", value)

    @property
    @pulumi.getter(name="commitDescription")
    def commit_description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the provided commit
        """
        return pulumi.get(self, "commit_description")

    @commit_description.setter
    def commit_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "commit_description", value)

    @property
    @pulumi.getter(name="filePath")
    def file_path(self) -> Optional[pulumi.Input[str]]:
        """
        Local path to a slug archive, `"slugs/current.tgz"`
        """
        return pulumi.get(self, "file_path")

    @file_path.setter
    def file_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_path", value)

    @property
    @pulumi.getter(name="fileUrl")
    def file_url(self) -> Optional[pulumi.Input[str]]:
        """
        **https** URL to a slug archive, `"https://example.com/slugs/app-v1.tgz"`
        """
        return pulumi.get(self, "file_url")

    @file_url.setter
    def file_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_url", value)

    @property
    @pulumi.getter(name="processTypes")
    def process_types(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Map of [processes to launch on Heroku Dynos](https://devcenter.heroku.com/articles/process-model)
        """
        return pulumi.get(self, "process_types")

    @process_types.setter
    def process_types(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "process_types", value)

    @property
    @pulumi.getter
    def size(self) -> Optional[pulumi.Input[int]]:
        """
        Slug archive filesize in bytes
        """
        return pulumi.get(self, "size")

    @size.setter
    def size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "size", value)

    @property
    @pulumi.getter
    def stack(self) -> Optional[pulumi.Input[str]]:
        """
        Name or ID of the [Heroku stack](https://devcenter.heroku.com/articles/stack)
        """
        return pulumi.get(self, "stack")

    @stack.setter
    def stack(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stack", value)

    @property
    @pulumi.getter(name="stackId")
    def stack_id(self) -> Optional[pulumi.Input[str]]:
        """
        [Heroku stack](https://devcenter.heroku.com/articles/stack) ID
        """
        return pulumi.get(self, "stack_id")

    @stack_id.setter
    def stack_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stack_id", value)


class Slug(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_id: Optional[pulumi.Input[str]] = None,
                 buildpack_provided_description: Optional[pulumi.Input[str]] = None,
                 checksum: Optional[pulumi.Input[str]] = None,
                 commit: Optional[pulumi.Input[str]] = None,
                 commit_description: Optional[pulumi.Input[str]] = None,
                 file_path: Optional[pulumi.Input[str]] = None,
                 file_url: Optional[pulumi.Input[str]] = None,
                 process_types: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 stack: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        Complete config to launch a Heroku app:

        ## Import

        Existing slugs can be imported using the combination of the application name, a colon, and the slug ID.

        For example:

        ```sh
        $ pulumi import heroku:slug/slug:Slug foobar bazbux:4f1db8ef-ed5c-4c42-a3d6-3c28262d5abc
        ```

        * `foobar` is the **heroku_slug** resource's name

        * `bazbux` is the Heroku app name (or ID) that the slug belongs to

        * `:` separates the app identifier & the slug identifier

        * `4f1db8ef…` is the slug ID

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[str] buildpack_provided_description: Description of language or app framework, `"Ruby/Rack"`;
               displayed as the app's language in the Heroku Dashboard
        :param pulumi.Input[str] checksum: Hash of the slug for verifying its integrity, auto-generated from contents of `file_path` or `file_url`,
               `SHA256:e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855`
        :param pulumi.Input[str] commit: Identification of the code with your version control system (eg: SHA of the git HEAD), `"60883d9e8947a57e04dc9124f25df004866a2051"`
        :param pulumi.Input[str] commit_description: Description of the provided commit
        :param pulumi.Input[str] file_path: Local path to a slug archive, `"slugs/current.tgz"`
        :param pulumi.Input[str] file_url: **https** URL to a slug archive, `"https://example.com/slugs/app-v1.tgz"`
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] process_types: Map of [processes to launch on Heroku Dynos](https://devcenter.heroku.com/articles/process-model)
        :param pulumi.Input[str] stack: Name or ID of the [Heroku stack](https://devcenter.heroku.com/articles/stack)
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SlugArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        Complete config to launch a Heroku app:

        ## Import

        Existing slugs can be imported using the combination of the application name, a colon, and the slug ID.

        For example:

        ```sh
        $ pulumi import heroku:slug/slug:Slug foobar bazbux:4f1db8ef-ed5c-4c42-a3d6-3c28262d5abc
        ```

        * `foobar` is the **heroku_slug** resource's name

        * `bazbux` is the Heroku app name (or ID) that the slug belongs to

        * `:` separates the app identifier & the slug identifier

        * `4f1db8ef…` is the slug ID

        :param str resource_name: The name of the resource.
        :param SlugArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SlugArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_id: Optional[pulumi.Input[str]] = None,
                 buildpack_provided_description: Optional[pulumi.Input[str]] = None,
                 checksum: Optional[pulumi.Input[str]] = None,
                 commit: Optional[pulumi.Input[str]] = None,
                 commit_description: Optional[pulumi.Input[str]] = None,
                 file_path: Optional[pulumi.Input[str]] = None,
                 file_url: Optional[pulumi.Input[str]] = None,
                 process_types: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 stack: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SlugArgs.__new__(SlugArgs)

            if app_id is None and not opts.urn:
                raise TypeError("Missing required property 'app_id'")
            __props__.__dict__["app_id"] = app_id
            __props__.__dict__["buildpack_provided_description"] = buildpack_provided_description
            __props__.__dict__["checksum"] = checksum
            __props__.__dict__["commit"] = commit
            __props__.__dict__["commit_description"] = commit_description
            __props__.__dict__["file_path"] = file_path
            __props__.__dict__["file_url"] = file_url
            if process_types is None and not opts.urn:
                raise TypeError("Missing required property 'process_types'")
            __props__.__dict__["process_types"] = process_types
            __props__.__dict__["stack"] = stack
            __props__.__dict__["blobs"] = None
            __props__.__dict__["size"] = None
            __props__.__dict__["stack_id"] = None
        super(Slug, __self__).__init__(
            'heroku:slug/slug:Slug',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            app_id: Optional[pulumi.Input[str]] = None,
            blobs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SlugBlobArgs', 'SlugBlobArgsDict']]]]] = None,
            buildpack_provided_description: Optional[pulumi.Input[str]] = None,
            checksum: Optional[pulumi.Input[str]] = None,
            commit: Optional[pulumi.Input[str]] = None,
            commit_description: Optional[pulumi.Input[str]] = None,
            file_path: Optional[pulumi.Input[str]] = None,
            file_url: Optional[pulumi.Input[str]] = None,
            process_types: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            size: Optional[pulumi.Input[int]] = None,
            stack: Optional[pulumi.Input[str]] = None,
            stack_id: Optional[pulumi.Input[str]] = None) -> 'Slug':
        """
        Get an existing Slug resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_id: Heroku app ID (do not use app name)
        :param pulumi.Input[Sequence[pulumi.Input[Union['SlugBlobArgs', 'SlugBlobArgsDict']]]] blobs: Slug archive (compressed tar of executable code)
        :param pulumi.Input[str] buildpack_provided_description: Description of language or app framework, `"Ruby/Rack"`;
               displayed as the app's language in the Heroku Dashboard
        :param pulumi.Input[str] checksum: Hash of the slug for verifying its integrity, auto-generated from contents of `file_path` or `file_url`,
               `SHA256:e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855`
        :param pulumi.Input[str] commit: Identification of the code with your version control system (eg: SHA of the git HEAD), `"60883d9e8947a57e04dc9124f25df004866a2051"`
        :param pulumi.Input[str] commit_description: Description of the provided commit
        :param pulumi.Input[str] file_path: Local path to a slug archive, `"slugs/current.tgz"`
        :param pulumi.Input[str] file_url: **https** URL to a slug archive, `"https://example.com/slugs/app-v1.tgz"`
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] process_types: Map of [processes to launch on Heroku Dynos](https://devcenter.heroku.com/articles/process-model)
        :param pulumi.Input[int] size: Slug archive filesize in bytes
        :param pulumi.Input[str] stack: Name or ID of the [Heroku stack](https://devcenter.heroku.com/articles/stack)
        :param pulumi.Input[str] stack_id: [Heroku stack](https://devcenter.heroku.com/articles/stack) ID
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SlugState.__new__(_SlugState)

        __props__.__dict__["app_id"] = app_id
        __props__.__dict__["blobs"] = blobs
        __props__.__dict__["buildpack_provided_description"] = buildpack_provided_description
        __props__.__dict__["checksum"] = checksum
        __props__.__dict__["commit"] = commit
        __props__.__dict__["commit_description"] = commit_description
        __props__.__dict__["file_path"] = file_path
        __props__.__dict__["file_url"] = file_url
        __props__.__dict__["process_types"] = process_types
        __props__.__dict__["size"] = size
        __props__.__dict__["stack"] = stack
        __props__.__dict__["stack_id"] = stack_id
        return Slug(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="appId")
    def app_id(self) -> pulumi.Output[str]:
        """
        Heroku app ID (do not use app name)
        """
        return pulumi.get(self, "app_id")

    @property
    @pulumi.getter
    def blobs(self) -> pulumi.Output[Sequence['outputs.SlugBlob']]:
        """
        Slug archive (compressed tar of executable code)
        """
        return pulumi.get(self, "blobs")

    @property
    @pulumi.getter(name="buildpackProvidedDescription")
    def buildpack_provided_description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of language or app framework, `"Ruby/Rack"`;
        displayed as the app's language in the Heroku Dashboard
        """
        return pulumi.get(self, "buildpack_provided_description")

    @property
    @pulumi.getter
    def checksum(self) -> pulumi.Output[str]:
        """
        Hash of the slug for verifying its integrity, auto-generated from contents of `file_path` or `file_url`,
        `SHA256:e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855`
        """
        return pulumi.get(self, "checksum")

    @property
    @pulumi.getter
    def commit(self) -> pulumi.Output[Optional[str]]:
        """
        Identification of the code with your version control system (eg: SHA of the git HEAD), `"60883d9e8947a57e04dc9124f25df004866a2051"`
        """
        return pulumi.get(self, "commit")

    @property
    @pulumi.getter(name="commitDescription")
    def commit_description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of the provided commit
        """
        return pulumi.get(self, "commit_description")

    @property
    @pulumi.getter(name="filePath")
    def file_path(self) -> pulumi.Output[Optional[str]]:
        """
        Local path to a slug archive, `"slugs/current.tgz"`
        """
        return pulumi.get(self, "file_path")

    @property
    @pulumi.getter(name="fileUrl")
    def file_url(self) -> pulumi.Output[Optional[str]]:
        """
        **https** URL to a slug archive, `"https://example.com/slugs/app-v1.tgz"`
        """
        return pulumi.get(self, "file_url")

    @property
    @pulumi.getter(name="processTypes")
    def process_types(self) -> pulumi.Output[Mapping[str, str]]:
        """
        Map of [processes to launch on Heroku Dynos](https://devcenter.heroku.com/articles/process-model)
        """
        return pulumi.get(self, "process_types")

    @property
    @pulumi.getter
    def size(self) -> pulumi.Output[int]:
        """
        Slug archive filesize in bytes
        """
        return pulumi.get(self, "size")

    @property
    @pulumi.getter
    def stack(self) -> pulumi.Output[str]:
        """
        Name or ID of the [Heroku stack](https://devcenter.heroku.com/articles/stack)
        """
        return pulumi.get(self, "stack")

    @property
    @pulumi.getter(name="stackId")
    def stack_id(self) -> pulumi.Output[str]:
        """
        [Heroku stack](https://devcenter.heroku.com/articles/stack) ID
        """
        return pulumi.get(self, "stack_id")

