# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'InboundRulesetRule',
    'VpnConnectionTunnel',
]

@pulumi.output_type
class InboundRulesetRule(dict):
    def __init__(__self__, *,
                 action: str,
                 source: str):
        """
        :param str action: The action to apply this rule to. Must be one of `allow` or `deny`.
        :param str source: A CIDR block source for the rule.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "source", source)

    @property
    @pulumi.getter
    def action(self) -> str:
        """
        The action to apply this rule to. Must be one of `allow` or `deny`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def source(self) -> str:
        """
        A CIDR block source for the rule.
        """
        return pulumi.get(self, "source")


@pulumi.output_type
class VpnConnectionTunnel(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "preSharedKey":
            suggest = "pre_shared_key"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VpnConnectionTunnel. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VpnConnectionTunnel.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VpnConnectionTunnel.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip: Optional[str] = None,
                 pre_shared_key: Optional[str] = None):
        """
        :param str ip: The public IP address of the tunnel.
        :param str pre_shared_key: The pre-shared IPSec secret for the tunnel.
        """
        if ip is not None:
            pulumi.set(__self__, "ip", ip)
        if pre_shared_key is not None:
            pulumi.set(__self__, "pre_shared_key", pre_shared_key)

    @property
    @pulumi.getter
    def ip(self) -> Optional[str]:
        """
        The public IP address of the tunnel.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter(name="preSharedKey")
    def pre_shared_key(self) -> Optional[str]:
        """
        The pre-shared IPSec secret for the tunnel.
        """
        return pulumi.get(self, "pre_shared_key")


